# coding: utf-8

"""
    Notification API

    The eBay Notification API enables management of the entire end-to-end eBay notification experience by allowing users to:<ul><li>Browse for supported notification topics and retrieve topic details</li><li>Create, configure, and manage notification destination endpoints</li><li>Configure, manage, and test notification subscriptions</li><li>Process eBay notifications and verify the integrity of the message payload</li></ul>  # noqa: E501

    OpenAPI spec version: v1.6.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SubscriptionFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'creation_date': 'str',
        'filter_id': 'str',
        'filter_schema': 'dict(str, object)',
        'filter_status': 'str',
        'subscription_id': 'str'
    }

    attribute_map = {
        'creation_date': 'creationDate',
        'filter_id': 'filterId',
        'filter_schema': 'filterSchema',
        'filter_status': 'filterStatus',
        'subscription_id': 'subscriptionId'
    }

    def __init__(self, creation_date=None, filter_id=None, filter_schema=None, filter_status=None, subscription_id=None):  # noqa: E501
        """SubscriptionFilter - a model defined in Swagger"""  # noqa: E501
        self._creation_date = None
        self._filter_id = None
        self._filter_schema = None
        self._filter_status = None
        self._subscription_id = None
        self.discriminator = None
        if creation_date is not None:
            self.creation_date = creation_date
        if filter_id is not None:
            self.filter_id = filter_id
        if filter_schema is not None:
            self.filter_schema = filter_schema
        if filter_status is not None:
            self.filter_status = filter_status
        if subscription_id is not None:
            self.subscription_id = subscription_id

    @property
    def creation_date(self):
        """Gets the creation_date of this SubscriptionFilter.  # noqa: E501

        The creation date for this subscription filter.  # noqa: E501

        :return: The creation_date of this SubscriptionFilter.  # noqa: E501
        :rtype: str
        """
        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """Sets the creation_date of this SubscriptionFilter.

        The creation date for this subscription filter.  # noqa: E501

        :param creation_date: The creation_date of this SubscriptionFilter.  # noqa: E501
        :type: str
        """

        self._creation_date = creation_date

    @property
    def filter_id(self):
        """Gets the filter_id of this SubscriptionFilter.  # noqa: E501

        The unique identifier for this subscription filter.  # noqa: E501

        :return: The filter_id of this SubscriptionFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_id

    @filter_id.setter
    def filter_id(self, filter_id):
        """Sets the filter_id of this SubscriptionFilter.

        The unique identifier for this subscription filter.  # noqa: E501

        :param filter_id: The filter_id of this SubscriptionFilter.  # noqa: E501
        :type: str
        """

        self._filter_id = filter_id

    @property
    def filter_schema(self):
        """Gets the filter_schema of this SubscriptionFilter.  # noqa: E501

        The content of this subscription filter as a valid <a href=\"https://json-schema.org \" target=\"_blank\">JSON Schema Core document</a> (version 2020-12 or later). The <strong>filterSchema</strong> provided must describe the subscription's notification payload such that it supplies valid criteria to filter the subscription's notifications.  # noqa: E501

        :return: The filter_schema of this SubscriptionFilter.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._filter_schema

    @filter_schema.setter
    def filter_schema(self, filter_schema):
        """Sets the filter_schema of this SubscriptionFilter.

        The content of this subscription filter as a valid <a href=\"https://json-schema.org \" target=\"_blank\">JSON Schema Core document</a> (version 2020-12 or later). The <strong>filterSchema</strong> provided must describe the subscription's notification payload such that it supplies valid criteria to filter the subscription's notifications.  # noqa: E501

        :param filter_schema: The filter_schema of this SubscriptionFilter.  # noqa: E501
        :type: dict(str, object)
        """

        self._filter_schema = filter_schema

    @property
    def filter_status(self):
        """Gets the filter_status of this SubscriptionFilter.  # noqa: E501

        The status of this subscription filter. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/notification/types/api:SubscriptionFilterStatus'>eBay API documentation</a>  # noqa: E501

        :return: The filter_status of this SubscriptionFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_status

    @filter_status.setter
    def filter_status(self, filter_status):
        """Sets the filter_status of this SubscriptionFilter.

        The status of this subscription filter. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/commerce/notification/types/api:SubscriptionFilterStatus'>eBay API documentation</a>  # noqa: E501

        :param filter_status: The filter_status of this SubscriptionFilter.  # noqa: E501
        :type: str
        """

        self._filter_status = filter_status

    @property
    def subscription_id(self):
        """Gets the subscription_id of this SubscriptionFilter.  # noqa: E501

        The unique identifier for the subscription.  # noqa: E501

        :return: The subscription_id of this SubscriptionFilter.  # noqa: E501
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """Sets the subscription_id of this SubscriptionFilter.

        The unique identifier for the subscription.  # noqa: E501

        :param subscription_id: The subscription_id of this SubscriptionFilter.  # noqa: E501
        :type: str
        """

        self._subscription_id = subscription_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
