# coding: utf-8

"""
    Taxonomy API

    Use the Taxonomy API to discover the most appropriate eBay categories under which sellers can offer inventory items for sale, and the most likely categories under which buyers can browse or search for items to purchase. In addition, the Taxonomy API provides metadata about the required and recommended category aspects to include in listings, and also has two operations to retrieve parts compatibility information.  # noqa: E501

    OpenAPI spec version: v1.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ExpiredCategories(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'expired_categories': 'list[ExpiredCategory]'
    }

    attribute_map = {
        'expired_categories': 'expiredCategories'
    }

    def __init__(self, expired_categories=None):  # noqa: E501
        """ExpiredCategories - a model defined in Swagger"""  # noqa: E501
        self._expired_categories = None
        self.discriminator = None
        if expired_categories is not None:
            self.expired_categories = expired_categories

    @property
    def expired_categories(self):
        """Gets the expired_categories of this ExpiredCategories.  # noqa: E501

        An array of expired category ID(s) for the requested category tree, and the currently active category ID(s) that have replaced them.  # noqa: E501

        :return: The expired_categories of this ExpiredCategories.  # noqa: E501
        :rtype: list[ExpiredCategory]
        """
        return self._expired_categories

    @expired_categories.setter
    def expired_categories(self, expired_categories):
        """Sets the expired_categories of this ExpiredCategories.

        An array of expired category ID(s) for the requested category tree, and the currently active category ID(s) that have replaced them.  # noqa: E501

        :param expired_categories: The expired_categories of this ExpiredCategories.  # noqa: E501
        :type: list[ExpiredCategory]
        """

        self._expired_categories = expired_categories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExpiredCategories, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExpiredCategories):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
