# coding: utf-8

"""
    Metadata API

    The Metadata API has operations that retrieve configuration details pertaining to the different eBay marketplaces. In addition to marketplace information, the API also has operations that get information that helps sellers list items on eBay.  # noqa: E501

    OpenAPI spec version: v1.9.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RegulatoryAttribute(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'usage': 'str'
    }

    attribute_map = {
        'name': 'name',
        'usage': 'usage'
    }

    def __init__(self, name=None, usage=None):  # noqa: E501
        """RegulatoryAttribute - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._usage = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if usage is not None:
            self.usage = usage

    @property
    def name(self):
        """Gets the name of this RegulatoryAttribute.  # noqa: E501

        A unique value identifying a specific regulatory attribute. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/sell/metadata/types/sel:RegulatoryAttributeEnum'>eBay API documentation</a>  # noqa: E501

        :return: The name of this RegulatoryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RegulatoryAttribute.

        A unique value identifying a specific regulatory attribute. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/sell/metadata/types/sel:RegulatoryAttributeEnum'>eBay API documentation</a>  # noqa: E501

        :param name: The name of this RegulatoryAttribute.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def usage(self):
        """Gets the usage of this RegulatoryAttribute.  # noqa: E501

        The enumeration value in this field indicates whether the corresponding attribute is recommended or required for the corresponding leaf category. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/sell/metadata/types/sel:GenericUsageEnum'>eBay API documentation</a>  # noqa: E501

        :return: The usage of this RegulatoryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._usage

    @usage.setter
    def usage(self, usage):
        """Sets the usage of this RegulatoryAttribute.

        The enumeration value in this field indicates whether the corresponding attribute is recommended or required for the corresponding leaf category. For implementation help, refer to <a href='https://developer.ebay.com/api-docs/sell/metadata/types/sel:GenericUsageEnum'>eBay API documentation</a>  # noqa: E501

        :param usage: The usage of this RegulatoryAttribute.  # noqa: E501
        :type: str
        """

        self._usage = usage

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RegulatoryAttribute, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegulatoryAttribute):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
